
Core - Task # 57168

Epic # 55070 (Accepted): Workpackages
Epic # 54851 (Accepted): WP: Workspaces IRRE & MM bugfixes
Story # 54853 (Accepted): As a user I want to correctly create, modify, preview and publish IRRE & MM related workspace changes

Status: Resolved Priority: Should have
Author: Oliver Hader Category: Frontend
Created: 2014-03-21 Assigned To: Oliver Hader
Updated: 2014-03-22 Due date:
TYPO3 Version: 6.2
PHP Version: 5.3
Complexity:
Sprint Focus:
Subject: Enable queries using "root" and "-1" for pidInList
Description

The version preview in the frontend rendering process basically selects only the live versions and then overlays those records with
possible versions.
Since the MM handling is changed to directly point to the most specific version in that regard (this is a exception to the "always live,
overlay then" approach), the versions also need to be selected directly. However, the ContentObjectRenderer uses
PageRepository::enableFields() which adds an additional SQL WHERE part, like " AND tablename.pid<>-1" to exclude possible
versions.

Besides that, elements (like sys_catagory) that are stored on the root-level cannot be queried at all which leads to custom code in the
end just to perform these queries.

This change allows selections on the root-level and disables the "pid<>-1" constraint if the opposite has been defined in the pidInList
property.

Related issues:
related to TypoScript Reference (TSref) - Feature # 57171: select: Enable que... Resolved 2014-03-22
related to Core - Bug # 33220: Empty content object when select.pidInList=0 s... Closed 2012-01-16
related to Core - Bug # 31209: CONTENT still can't select records from rootpage Closed 2011-10-24

Associated revisions
Revision 20acc401 - 2014-03-22 01:44 - Oliver Hader

[FEATURE] Enable queries using "root" and "-1" for pidInList

The version preview in the frontend rendering process basically
selects only the live versions and then overlays those records
with possible versions. Since the MM handling is changed to
directly point to the most specific version in that regard (this
is an exception to the "always live, overlay then" approach), the
versions also need to be selected directly. ContentObjectRenderer
uses the method PageRepository::enableFields() which adds an
additional SQL WHERE part, like " AND tablename.pid<>-1" to
exclude possible versions.

Besides that, elements (like sys_catagory) that are stored on the
root-level cannot be queried at all which leads to custom code in
the end just to perform these queries.
This change allows selections on the root-level and disables the
"pid<>-1" constraint if the opposite has been defined in the
pidInList property.

Example:
select.pidInList = root,-1

Resolves: #57168
Documentation: #57171
Releases: 6.2
Change-Id: I6fb91f89f70614d59c83d808f07e890833248880
Reviewed-on: https://review.typo3.org/28623
Reviewed-by: Ernesto Baschny
Reviewed-by: Oliver Hader
Tested-by: Oliver Hader

History
#1 - 2014-03-21 22:18 - Oliver Hader
- Subject changed from Introduce possibility to select version records directly to Enable record queries with pidInList=0,-1

#2 - 2014-03-21 22:24 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28623

#3 - 2014-03-21 23:35 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28623

#4 - 2014-03-22 00:04 - Oliver Hader
- Subject changed from Enable record queries with pidInList=0,-1 to Enable queries using "root" and "-1" for pidInList

#5 - 2014-03-22 00:06 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28623

#6 - 2014-03-22 00:35 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28623

#7 - 2014-03-22 02:30 - Oliver Hader
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100
Applied in changeset commit:20acc4019a14c97431400a4c13b7762c1bbcecc2.
